#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <graphics.h>
#include <string.h>
#include <dos.h>
#include <bios.h>     /* for biostime */
#include <math.h>     /* floor,ceil,fabs */
#include <graph.h>
#include <spline.h>

extern void Control_Range (float X);
extern int Interval(float X);
extern void MoreInfo (FILE *,int far *);
extern CASE far tabl1[],  far tabl6[], far tabl9[], far tabl10[],
            far tabl13[], far tabl17[];
extern CASE far tabl2[],far tabl3[],far tabl4[];
extern CASE far tabl33[],far tabl12[],far tabl31[];
extern MODE Har;
extern float Wide,Usv; extern int Ideriv; //   ..
extern void Load_Dir (void);

extern FUN Ext_Function;
extern int Type;
extern MODE Thank;
extern char Mouse,buttons;
extern CASE File_Error,File_Help,Format_Error,No_Error,No_Help,
  Format_Help,File_Ok;
extern int File_Mode, Load_Flag;

void Renew_Data (void), Renew_Spline (void),
 Renew_Rab (void), Renew_Dmat (void);
int Apriory_Info(void); void Change_Tabl (int); void Begin_Bilding( void );
int DataPlusSpline (int,int far *,int far *);
int RealLen(void); void Print_Data(void);
void Apr_View(int,int,const  int ); void Report_File(void);
float S1( float ),DS1 ( float ),DDS1( float );

char far *File_Name=        "*.dat        ",
     far *Mask     =        "*.*          ";
char far *Left_Param_Char  ="0.0          "; // ࠥ
char far *Right_Param_Char =" 0.0         "; // ᫮
int Side_Kraev = 2;
static float difftime_; // ६ 
int Pos; // Position for Show_Data
static char far *v5[3] = { "&㧫", " 祭& 㧫",
 " &࠭祭" };
static int far p5[2] = { 85, 210 };
 SHOW_RECORD data5 = {
 " ", 125,13,505,MAXY-14, 2,3, v5, p5, Apr_View };
static char far *vr[8];
static char far *vstr[8] = {
  "-&&㧫", " &",
  "窠&","祭&㭪樨","祭&ᯫ",
  "離","ࢠ&ந-&",
  "&ந-&" };
static int far pr[7] = { 55,130,215,300,385,470,555 };
 SHOW_RECORD datar = { "    ",
   0,13,640,MAXY-14, 3, 1, vr, pr, Report_View };
int dpos,spos;

////////////////////////////////////////////////////////////////////////
int PrnPage=40; MODE PrnSet=0x42;
// xxxx xxx1 -   ࠭
// xxxx xx1x -  
// xxxx x1xx - 㬥 ࠭
// xxxx 1xxx -  ⠡
// xxx1 xxxx - 㭪. ப
// x1xx xxxx -  뢠   ᮮ饭
// 1xxx xxxx - OFF - Last string is , ON is Ŀ
MODE Flag_Prn; // 0 -Data, 1 -Spline, 2 - Report
FILE *Printfile;
static char far Printname[13]="prn";
// for REPORT creation:
MODE RepTo; // Report to: 0 - screen,1 - file,2 - printer
MODE Rep=0x00; // Report status
// xxxx xxx1 - Knots numbers and initial data
// xxxx xx1x - Spline net data
// xxxx x1xx - Spline
// xxxx 1xxx - Spline error
// xxx1 xxxx - 1st deriv.
// xx1x xxxx - 2nd deriv.
// x1xx xxxx - More Info
// 1xxx xxxx - 室 祭
/*static*/ int Show_X1, Show_X2, Show_Y1, Show_Y2;
 int Hi_Data, Kol, Loc;
 SHOW_RECORD far *Tmp;
 TEXT_FUN Paint;
#define SHOW_COLOR LIGHTCYAN
 int Lendata;
MODE Where=0x00;
// 1xxx xxxx - In Data or in Spline array we are now?

int Left_Kr_Param=2, Right_Kr_Param=2, Disp_Param=4, Lseg;
float Left_Value = 0.0, Right_Value = 0.0;
int  Vid_Param = 2;
float epsv=0.,Disp=0.,mid_disp,All=1.0e+8,chal=-1.;
float Al_0;  //  ࠬ ᣫ !!!
float Al_N;
int altype=0;

const unsigned sfl=sizeof(float);
MODE What=0x04;
// xxxx xxx1 - ஢  ᯫ
// xxxx xx1x -   ,    
// xxxx x1xx -  ਮ ଠ
// 1xxx xxxx -   䠩  ᮧ!
//    float **U1,**Q,**AH,**DM,**M=NULL; // ⥫   
    // ஥ ਯ⨢ ᯫ

int Nrec=0;

int  Len_Data,Spline_Len;
int Len_Data_Beg,Spline_Len_Beg;

#define LEN_DATA 65U
#define SPLINE_LEN 100U
//float far  P[LEN_DATA],far  V[LEN_DATA],
//far  Rab[15*LEN_DATA*LEN_DATA+15*LEN_DATA] , // !!!  //[8*LEN_DATA*LEN_DATA+23*LEN_DATA],
//far  Rab2[13*LEN_DATA];
//float far  DataX[LEN_DATA],far  DataY[LEN_DATA],
//far  SplineX[LEN_DATA+10],far  SplineY[LEN_DATA+10];
//DATA Data_Array={&DataX[0],&DataY[0]}; DATA Spline_Array={&SplineX[0],&SplineY[0]};
//float far DmatPtr[3*LEN_DATA],far Dvec[LEN_DATA],far Dvec2[LEN_DATA],far *Dmat[LEN_DATA];
 DATA Data_Array = { NULL, NULL };
 DATA Spline_Array = { NULL, NULL };
 float far *P,  far *V,  far *Rab, far *Rab2; // *DS,  *DDS,   *R; // float  **Mrab=NULL;
 float  far *DmatPtr=NULL,  far *Dvec, far *Dvec2; //far * far *Dmat,

static int Old_Data,Old_Spline,Old_Dmat;
static unsigned long OLD_RABLEN;

void Free_Data(void) {
 farfree( Data_Array.X ); farfree( Data_Array.Y );
 Data_Array.X=NULL;
}

void Renew_Data (void) {
 if (Old_Data!=Len_Data) {
  Old_Data=Len_Data;
  if( Data_Array.X != NULL ) {
   Free_Data();
  }
  Data_Array.X = (float far *)farcalloc( (unsigned long)Len_Data, sfl );
  Data_Array.Y = (float far *)farcalloc( (unsigned long)Len_Data, sfl );
  if (Data_Array.Y==NULL) Close_System();
 }
 return;
}

void Free_Spline(void) {
 farfree( Spline_Array.X ); farfree( Spline_Array.Y );
 Spline_Array.X=NULL;
}

void Renew_Spline (void) {
 if (Old_Spline!=Spline_Len) {
  Old_Spline=Spline_Len;
  if( Spline_Array.X != NULL ) {
   Free_Spline();
  }
  Spline_Array.X = (float far *)farcalloc( (unsigned long)Spline_Len, sfl );
  Spline_Array.Y = (float far *)farcalloc( (unsigned long)Spline_Len, sfl );
  if (Spline_Array.Y==NULL) Close_System();
 }
 return;
}

void Free_Rab (void) {
 farfree( V );  // free( DS ); free( DDS ); free( R );
 farfree( P ); farfree( Rab2 ); farfree( Rab ); Rab=NULL;
}

void Renew_Rab (void) {
 unsigned long RABLEN;
 RABLEN = 13*Len_Data;
 if (RABLEN!=OLD_RABLEN) {
  OLD_RABLEN=RABLEN;
  if (Rab!=NULL) {
   Free_Rab();
  }
//   if (What&0x01 && tabl13[2].zam && Mrab!=NULL) free (Mrab);
//   DS = (float *)calloc( Len_Data, sfl );
//   DDS = (float *)farcalloc( Len_Data, sfl );
//   R = (float *)calloc( Len_Data, sfl );
  P = (float far *)farcalloc( (unsigned long)Len_Data, sfl );
  V = (float far *)farcalloc( (unsigned long)Len_Data, sfl );
  Rab2=(float far *) farcalloc( (unsigned long)RABLEN, sfl );
  if (Rab2== NULL)  Close_System();
  if (What&0x01 && tabl13[2].zam) { // ਯ⨢
   RABLEN = (unsigned long)(15*Len_Data*Len_Data+15*Len_Data); // (6*Len_Data*Len_Data+10*Len_Data);
   //    Mrab=(float **) malloc ((9*Len_Data)*sizeof(float *));
  }
  Rab = (float far *) farcalloc( (unsigned long)RABLEN, sfl );
  if (Rab==NULL)  Close_System();
 }
 return;
}

void Free_Dmat(void) {
 farfree( DmatPtr ); farfree( Dvec );  //farfree (Dmat);
 DmatPtr=NULL; Nrec=0;
}

void Renew_Dmat (void) {
 int ii;
 if (Old_Dmat!=Len_Data_Beg) {
  Old_Dmat=Len_Data_Beg;
  if (DmatPtr!=NULL) {
   Free_Dmat();
  }
  DmatPtr = (float far *) farcalloc( (unsigned long)4*Len_Data_Beg, sfl);
  Dvec = (float far *) farcalloc( (unsigned long)2*Len_Data_Beg, sfl );
  //Dmat=(float far * far *) farcalloc( (unsigned long)Len_Data_Beg, sizeof(float far *) );
  if (DmatPtr==NULL || Dvec==NULL) Close_System();
/*  for (ii=0; ii<Len_Data_Beg; ii++) {
   Dmat[ii]=&(DmatPtr[3*ii]);
   Dmat[ii][0]=Data_Array.X[ii];
   Dmat[ii][1]=Dmat[ii][2]=0.;
   Dvec[ii]=0.;
  }
  for (ii=Len_Data_Beg; ii<2*Len_Data_Beg; ii++) Dvec[ii]=0.;
  */
  for (ii=0; ii<Len_Data_Beg; ii++) {
   DmatPtr[3*ii]=Data_Array.X[ii];
   DmatPtr[3*ii+1]=0.0;
   DmatPtr[3*ii+2]=0.0;
   DmatPtr[3*Len_Data+ii]=-1.0;
   Dvec[ii]=0.0;
  }
  for (ii=Len_Data_Beg; ii<2*Len_Data_Beg; ii++) Dvec[ii]=0.0;
  Dvec2=&(Dvec[Len_Data_Beg]);
 }
 return;
}

void Apr_View(int x,int y,const  int pos ) {
 MODE Sign=' ',Npor='0';
 if (DmatPtr[3*pos+2]==1.) Sign='<';
 else if (DmatPtr[3*pos+2]==-1.) Sign='>';
 Npor=(char)((char)(DmatPtr[3*pos+1])+'0');
 Gprintf( x, y, (char far *)" %-4d     %-9.5f      [%c] %c %-9.4f",
  pos+1, DmatPtr[ 3*pos ], Npor, Sign, Dvec[pos]);
}

#define X1a 185
#define Y1a 90
int Apriory_Info (void) {
 CASE Help = {
  154,100,504,238,14,12,0,"",
  "   $஡$     㧫&"
  "⪨ ࠭祭   ந 0,&"
  "1  2 浪&"
  "  㤥 ।  冷&"
  "ந,   祭 ࠭祭&"
  " ।,  ࠭祭 ନ-&"
  "  ࢠ,  砫&"
  "  ࠬ 㧫&"
  "  \" ࠭祭\" 뢮&"
  "$[$冷 ந.$]$ $[$$]$ $[$祭  㧫$]$", Nop };
 char far *Bar[2]={
  "$ESC$ ⪠  $ENTER$   $SPACE$   $PAGE UP$   $PAGE DOWN$ ",
  "⬥ ஡ ன 㧥 ࢠ ࠭祭;  ࢮ =      "};
 KEY Bar_Keys[5]={ESC,ENTER,S_BAR,PAGE_UP,PAGE_DO};
 int Pos_Keys[6]={15,103,199,311,431,551};
 char Num_Keys=5;
 VID opr01= { X1a+8, Y1a+8, X1a+116, Y1a+88, 0x22,
  "冷&ந","0)0)1!1!2@2\""  };
 static char far *Hlp01="   -&"
		    "冷 ந, &"
		    " &"
		    "࠭祭";
 CASE   tabl01[3] = {
  {X1a, Y1a,X1a+190, Y1a+82, 14,12,1,"$0$ 㫥",Hlp01, Esc_Key},
  {X1a, Y1a+10,X1a+190, Y1a+92, 14,12,0,"$1$ ",Hlp01, Esc_Key},
  {X1a, Y1a+20,X1a+190, Y1a+102, 14,12,0,"$2$ ன",Hlp01,Esc_Key}
 };
 VID   opr02= { X1a+118, Y1a+8, X1a+226, Y1a+88, 0x21,
  "  &࠭祭",",<.>eE" };
 static char far *Hlp02="   &"
		       "࠭祭  -&"
		       " &"
		       "浪   .";
 CASE   tabl02[2] = {
  {X1a, Y1a,X1a+190, Y1a+82, 14,12,1,"$<$ ",Hlp02,  Esc_Key},
  {X1a, Y1a+10,X1a+190, Y1a+92, 14,12,0,"$>$ ",Hlp02,  Esc_Key}
 };
 MENU opr03= { X1a+18, Y1a+88, X1a+218, Y1a+133, 1,
	       " ࠭祭:" };
 CASE   tabl03[1] = {
  { X1a+10,Y1a,X1a+198,Y1a+72, 12,10,0,"",
       "   -&"
       " - ࠭祭 &"
       "ந  㧫&", Esc_Key} };
 static MODE poit00[2]; static char far Sbuf[14],Snum[4];
 float Buf,Npor=0.,Nsig=-1.; KEY Sim;
 int Str=0,Pages=0,Kol_Page,Ktp,x_1,x_2,y,i,j,N1,N2,Bi=0;
 MODE Change=0x81;
 // xxxx xxx1 - New page
 // xxxx xx1x - In diapason
 // 1xxx xxxx - Function bar
 Ktp=(data5.Y2 - data5.Y1)/11-5;
 Kol_Page=Len_Data/Ktp;
 if (Len_Data%Ktp!=0) Kol_Page++;
 Pos=0;
 x_1=data5.X1+data5.Line[0]+1; x_2=x_1+data5.Line[1]-data5.Line[0]-1;
 y=data5.Y1+50; Clear_Buf ();  Type=4;
 do {
  if (Change&0x01) {
   Pos=Pages*Ktp;
   Set_Key (1,ESC); Show_Data (&data5);
   Change&=0xfe;
  }
  if (Change&0x80) { Change&=0x7f; Fun_Bar (Bar[Bi]); }
  Chand( x_1, y, x_2, y+11, 3, XORI );
  if (Mouse) while (!Hit_Key()) {
   ms_state();
   if (buttons==0x01) {
    if (Change&0x02);
    else if (Fun_Bar_Keys (Num_Keys,Bar_Keys,Pos_Keys)) goto KEYBOARD;
    if (Mouse_In_Field(x_1,data5.Y1+50,x_2-x_1,11,1,Ktp,0,0,LIGHTCYAN,&i,&j)) {
     if (Str==j) Set_Key (1,S_BAR);
     else { Set_Key (1,TAB); Str=j; }
     goto KEYBOARD;
    }
   }
  }
KEYBOARD: Sim = Get_Key();
  Chand( x_1, y, x_2, y+11, 3, XORI );
  switch( Sim ) {
   case TAB: break;
   case F1:  if (!(Change&0x02)) {
    Message_Text( &Help); Change|=0x80; } break;
   case UP:
    if (Str>0) Str--;   else Set_Key (1,PAGE_UP);
   break;
   case DOWN:
    if (Str<Ktp-1) Str++;   else Set_Key (1,PAGE_DO);
   break;
   case PAGE_UP:
    if (Str>0) Str=0;
    else if (Pages>0) { Pages--; Str=0; Change|=0x81; }
   break;
   case PAGE_DO:
    if (Str<Ktp-1) Str=Ktp-1;
    else if (Pages< Kol_Page-1 || Pos+Str< Len_Data-1) {
     Pages++; Str=0; Change|=0x81; }
   break;
   case S_BAR:
   if (Pos+Str<Len_Data) {
    if (Change&0x02) {
     N2=Pos+Str;
     if (N2<N1) { i=N1; N1=N2; N2=i; }
     for (i=N1; i<=N2; i++) {
      DmatPtr[3*i+1]=(float)Npor;
      DmatPtr[3*i+2]=(float)Nsig;
      Dvec[i]=(float)Buf;
     }
     Nrec+=(N2-N1+1);
     Change&=0xfd; Change|=0x81; Bi=0;
    }
    else { CURSOR_OFF();
     setfillstyle( SOLID_FILL, LIGHTCYAN );
     bar( X1a, Y1a, X1a+240, Y1a+140 );
     setcolor ( BLACK );
     rectangle( X1a+2, Y1a+2, X1a+238, Y1a+138 );
     rectangle( X1a+4, Y1a+4, X1a+236, Y1a+136 ); CURSOR_ON();
MENU_1:
     Thank|=0x10;
     Init_Case_Wnd ( &opr01, tabl01, &(poit00[0]) );
     for (i=0; i<3; i++) if (tabl01[i].zam) break;
     if (!(Thank&0x08)) { Npor=0.; Nsig=0.; Buf=0.;
      goto MENU_ALL; }
     Npor=(float)(i);
MENU_2:
     Thank|=0x10;
     Init_Case_Wnd ( &opr02, tabl02, &(poit00[1]) );
     if (!(Thank&0x08)) goto MENU_1;
     if (tabl02[0].zam) Nsig=1.;
     else Nsig=-1.;
MENU_3:
     Thank|=0x10;
     Geting_Text( &opr03, tabl03, Sbuf);
     if (!(Thank&0x08)) goto MENU_2;
     Buf=atof (Sbuf);
MENU_ALL:
     N1=Pos+Str; itoa (N1+1,Snum,10);
     _fstrncpy (&(Bar[1][69]),Snum,4);
     Change|=0x83; Bi=1;
    }
   }
   break;
   case ENTER:
    if (!(Change&0x02)) goto END_AP; // Bi==0
   break;
   case ESC: Bi=1; goto ABORT_AP;
  }
  y=data5.Y1+50+Str*11;
 } while (1);
 END_AP:
 //   ଠ樨:
 Nrec=0; // 騩 㧥  ᫮ ࠭祭
 for (i=0; i<Len_Data; i++) {
  if (DmatPtr[3*i+2]!=0.0) { //     㧫
   for (j=0; j<3; j++) DmatPtr[3*Nrec+j]=DmatPtr[3*i+j];
   DmatPtr[3*Len_Data+Nrec]=i;
   Dvec[Nrec]=Dvec[i];
   Dvec2[Nrec]=Dvec[i];
   Nrec+=1;
  }
 }
 for (i=Nrec; i<Len_Data; i++) DmatPtr[3*Len_Data+i]=-1.0;
 ABORT_AP:
 // 室:
 CURSOR_OFF(); setcolor (11);
 rectangle( data5.X1+4, data5.Y1+4, data5.X2-4, data5.Y2-4 );
 rectangle( data5.X1+2, data5.Y1+2, data5.X2-2, data5.Y2-2 );
 CURSOR_ON(); return (Bi);
}

//////////////////////////////////////////////////////////////////////////
void Load_File( void ) {
 int Ind; FILE  *file; int Is=0,Setka=0;
 char  Key[10];
 float fnum,num,n1,n2,n3;

 if (Load_Flag) { //㧨
  do { AGAIN:
   file = fopen( File_Name, "rt" );
   if( file == NULL ) {
    if (_fstrchr (File_Name,'*') || _fstrchr (File_Name,'?')) {
     _fstrcpy (Mask,File_Name);
     Load_Dir();
     if (File_Name[0]=='\x0') { Set_Key(1,ESC); return; }
     goto AGAIN;
    }
    else {
     Common_Menu( &File_Error, &File_Help-1, E_RROR );
     _fstrcpy (File_Name,(char far *)"*.dat");
    }
   }
   else Is=1;
  } while (Is==0);
  if (Is) {
   if (File_Mode==0) { //室 
    for( Len_Data = 0; !feof( file ); Len_Data++ )
     if( !fscanf( file, "%g", &num ) ) goto FMT_ERROR;
    Len_Data >>= 1;
    if (Len_Data>LEN_DATA) Len_Data=LEN_DATA; //!!!
    Renew_Data();
    rewind( file );
    for( Ind = 0; Ind < Len_Data; Ind++ ) {
     fscanf( file, "%g", &num );
     Data_Array.X[ Ind ] = num;
     fscanf( file, "%g", &num );
     Data_Array.Y[ Ind ] = num;
    }
    smurr5( &Len_Data, Data_Array.X, Data_Array.Y );
    Len_Data_Beg=Len_Data;
   } // if
   else { //-
    if ( (!fscanf( file, "%s", Key )) || (strnicmp (Key,"SPLINE",6)!=0) ||
         (!fscanf( file, "%d %d %d", &Spline_Len, &Len_Data, &Setka)) ||
         (Spline_Len<=4 || Len_Data<=4)
       ) goto FMT_ERROR;
    for (Ind=0; Ind<3; Ind++) tabl17[Ind].zam=(Setka==Ind?1:0);
    if (Len_Data>LEN_DATA) Len_Data=LEN_DATA; //!!!
    Renew_Data();
    Renew_Rab();
    if (Spline_Len>SPLINE_LEN) Spline_Len=SPLINE_LEN; //!!!
    Renew_Spline ();
    What&=0xfe;
    for( Ind = 0; Ind < Spline_Len; Ind++ ) {
     fscanf( file, "%g %g %g %g", &fnum,&n1,&n2,&n3 );
     Spline_Array.X[ Ind ] = fnum;  Spline_Array.Y[ Ind ] = n1;
    }
    Spline_Len_Beg=Spline_Len;
    for( Ind = 0; Ind < Len_Data; Ind++ ) {
     fscanf( file, "%g %g", &fnum,&n1);
     Data_Array.X[ Ind ] = fnum;  Data_Array.Y[ Ind ] = n1;
    }
    for( Ind = 0; Ind < Len_Data*13; Ind++ ) {
     fscanf( file, "%g", &fnum);   Rab[Ind]=fnum;
    }
   } // else
   What|=0x04; // For Renew_Dmat
   Change_Tabl (File_Mode);
   Message_Text( &File_Ok ); Type=0;
   goto ESC_AND_GO;
  } // if Is
 } // 㧨
 else { // 
  if( (file = fopen( File_Name, "wt" )) == NULL ) {
   Common_Menu( &File_Error, &File_Help-1, E_RROR );
   goto ESC_AND_GO;
  }
  else {
   if (File_Mode==0) { //室 
    for(  Ind = 0; Ind < Len_Data; Ind++ ) {
     if( !fprintf( file, "%-9.5g   %-9.5g \n",
      Data_Array.X[ Ind ], Data_Array.Y[ Ind ]) ) goto WRITE_ERROR;
    }
   }
   else {
    if (Spline_Array.X!=NULL && Rab!=NULL) {  //-
     strcpy (Key,"SPLINE"); //!!!
     if ( !fprintf( file, "%s\n", Key )) goto WRITE_ERROR;
     for (Ind=0,Setka=0; Ind<3; Ind++,Setka++) if (tabl17[Ind].zam) break;
     fprintf( file, "%d %d %d\n", Spline_Len, Len_Data,Setka);
     for(  Ind = 0; Ind < Spline_Len; Ind++ ) {
      num= Spline_Array.X[ Ind ];
      if( !fprintf ( file, "%-9.5g    %-9.5g    %-9.5g   %-9.5g \n",
	  num , S1(num), DS1(num), DDS1(num) ) )
	  goto WRITE_ERROR;
     }
     for( Ind = 0; Ind < Len_Data; Ind++ ) {
      fnum=Data_Array.X[ Ind ];  n1 = Data_Array.Y[ Ind ];
      fprintf( file, "%g %g\n", fnum, n1);
     }
     for( Ind = 0; Ind < Len_Data*13; Ind++ ) {
      fnum=Rab[Ind];
      fprintf( file, "%g ", fnum);
     }
    }
    else { //  ᯫ  
     Common_Menu( &No_Error, &No_Help-1, E_RROR );
     goto ESC_AND_GO;
    }
   }
   goto WRITE_OK;
WRITE_ERROR:
   Common_Menu( &Format_Error, &Format_Help-1, E_RROR );
   goto ESC_AND_GO;
WRITE_OK:
   Message_Text( &File_Ok );
   goto ESC_AND_GO;
  } //else
 }  // 
FMT_ERROR:
 Common_Menu( &Format_Error, &Format_Help-1, E_RROR );
ESC_AND_GO:
 Set_Key( 1, ESC ); fclose (file); return;
}

void Change_Tabl (int Mode) {
 const char POPUP_ON1=0, POPUP_ON2=12, POPUP_OFF=13,
  SWITCH_ON=14, SWITCH_OFF=1;
 int i;
 // (+) .,.஢
 tabl1[ 1 ].color1 =  tabl1[4].color1=POPUP_ON1;
 tabl1[ 1 ].color2 =  tabl1[4].color2=12;
 // (+) ਭ._
 tabl2[ 0 ].color1 = POPUP_ON1; tabl2[ 0 ].color2 = POPUP_ON2;
 // (+) ࠡ⪠
 tabl3[ 0 ].color1 = tabl3[ 1 ].color1 =  POPUP_ON1;
 tabl3[ 0 ].color2 = tabl3[ 1 ].color2 =  POPUP_ON2;
 // (+) .(஬ ࠬ,ᯥ)
 tabl4[ 0 ].color1 = tabl4[ 1 ].color1 = tabl4[ 2 ].color1 =
 tabl4[ 5 ].color1 = POPUP_ON1;
 tabl4[ 0 ].color2 = tabl4[ 1 ].color2 = tabl4[ 2 ].color2 =
 tabl4[ 5 ].color2 = POPUP_ON2;
 // (+) 䨪 -- .,  --  㭪樨  祭
 tabl10[ 0 ].color1 = tabl9[ 0 ].color1 = tabl9[ 2 ].color1 = SWITCH_ON;
 // (+) ..
 tabl6[0].color1 =POPUP_ON1;	tabl6[0].color2 =POPUP_ON2;
 if (Mode) {   //Spline file reading;
  // (+) ਭ._ᯫ
  tabl2[ 1 ].color1 = POPUP_ON1; tabl2[ 1 ].color2 = POPUP_ON2;
  // (+)  ᯫ
  tabl6[ 2].color1 =  POPUP_ON1; tabl6[ 2 ].color2 = POPUP_ON2;
  // (+) 䨪, ந (tabl10)
  for (i=1; i<5; i++) tabl10[ i ].color1 = SWITCH_ON;
 }
 else { // ⠫ 室 
  // (-) ਭ._ᯫ,_
  tabl2[ 1 ].color1 = tabl2[ 1 ].color2 =
  tabl2[ 2 ].color1 = tabl2[ 2 ].color2 = POPUP_OFF;
  // (-) 䨪, ந (tabl10)
  for (i=1; i<5; i++) tabl10[ i ].color1 = SWITCH_OFF;
  // (-) ._
  tabl1[ 2 ].color1 = tabl1[ 2 ].color2 = POPUP_OFF;
  // (-) 䨪.ࠪ⨪,,_,䨪
  tabl6[1].color1= tabl6[1].color2= tabl6[2].color1= tabl6[2].color2=
  tabl6[4].color1= tabl6[4].color2= tabl6[6].color1= tabl6[6].color2=POPUP_OFF;
 }
}

///////////////////////////////////////////////////////////////////////
void PrintLine(FILE *,MODE,int,int far *);

void Print_Data( void ) {
 int Ind,j,strnum,page,Rep_Len; KEY k;
 CASE
// Prn_Error = { 218, 100, 456, 160, 14, 12, 0, "",
//  " ਭ  ⮢  ࠡ.&"
//  "    த ࠡ ?" } ,
       Load_Prn    = { 194, 100, 464,160, 14,12, 0, "",
  " ⮢ ਭ  ࠡ&"
  "     ENTER" },
       New_Page    = { 194, 100, 464,160, 14,12, 0, "",
  " ⮢  ࠭&"
  "     ENTER" },
       Prn_Ok    = { 238, 100, 420,150, 14,12, 0, "",
  " 襭" },
       Prn_Stop  = { 238, 100, 420,150, 14,12, 0, "",
  "ࢠ ?" };
 int Kol[3][2]= { {6,-13}, {6,-13}, {4,-9} };
 int Wides[3]={36,64,76}; int How[3]={3,5,8};
 char far *Fmt[3] = {
  " %-4d   %-9.4g    %-9.4g  \n",                       // Wide=36
  " %-4d   %-9.4g    %-9.4g    %-9.4g    %-9.4g  \n", // Wide=64
  "" };                                                 // Max Wide=76
 char far *Hdr[3]={
  "     䠩 ᮤন 祭\n      ᯥਬ⠫ .\n",
  "      䠩 ᮤন ,  ன ⠫ ᯫ,\n              祭 ᯫ   ந\n",
  "     䠩 - , ᣥ஢ ணࠬ SPLINE\n" };
 char far *Cols[2]={
  "             祭",
  "                     1- .       2- ." };
 char far *ColsRep[8]={
 "","","","祭","","離","1- .","2- ."};
 PrnSet|=0x10;
 if (PrnSet&0x40) {
  while (Prn_Status()==-1) {
   Message_Text( &Load_Prn );
   if (!(Thank&0x08))  return;
  }
 }
 if ( (Printfile = fopen( Printname, "at" )) == NULL ) {
  Mistake (116); What|=0x80; return; }

 if (Flag_Prn==0x02) {      // .  -  祭,   
  RepTo=0x02;  Show_R();
  How[2]=datar.Kol_Punct;  Wides[2]=5+(How[2]-1)*10;
  Rep_Len=RealLen();
 }

 strnum=0; page=1; fflush (Printfile);
 if (PrnSet&0x02) { // Header

  if (File_Name[0]!='\0') {
   k=Wides[Flag_Prn]/2-9;
   for (j=0;j<k; j++) fprintf (Printfile,"%c",' ');
   fprintf (Printfile," %-13s \n",File_Name); strnum++;
  }
  fprintf( Printfile,"%s",Hdr[Flag_Prn]);

  if (Flag_Prn>0x01) { //       !
   if (Rep&0x80) MoreInfo (Printfile,&strnum);
   fprintf( Printfile,"%-7s",ColsRep[0]);
   for (j=0; j<7; j++) {
    if (Rep&(0x01<<j)) fprintf (Printfile,"%-10s",ColsRep[j+1]);
   }
  }
  else fprintf( Printfile,"%s",Cols[Flag_Prn]);
  fprintf( Printfile,"\n");
  strnum+=3;
 }

 if (PrnSet&0x08) { // Border
  PrintLine (Printfile,0x00,How[Flag_Prn],Kol[Flag_Prn]); strnum++; PrnSet|=0x80;
  PrnPage--;
 }
 else { //  ࠧ⥫  ஡
  j=0;
  do {
   if (Fmt[Flag_Prn][j]=='') Fmt[Flag_Prn][j]=' ';
   j++;
  } while (Fmt[Flag_Prn][j]!='\0');
 }
 for( Ind=0,k=0;;Ind++,k=0)  { // Data , Spline , Report
  if (PrnSet&0x10) {
   PrnSet&=0xef; Fun_Bar ((char far *)"$ESC$ - ࢠ ");
  }
//  if ((PrnSet&0x40) && (Prn_Status()==-1) ) {
//   if (!Answ_Menu (&Prn_Error)) { PrnSet|=0x10; continue; }
//   else goto PRN_OUT;
//  }
  if (Hit_Key()) {
   k=Get_Key();
   if ( (PrnSet&0x40) && (k==ESC) && (!Answ_Menu(&Prn_Stop)) ) goto PRN_OUT;
   PrnSet|=0x10; continue;
  }
  else if (strnum==PrnPage) { // Page control
   if (PrnSet&0x08) { // Low border
    PrintLine (Printfile,0x02,How[Flag_Prn],Kol[Flag_Prn]); PrnSet&=0x7f; }
   strnum=0; page++;
   if (PrnSet&0x40) fprintf( Printfile,"\f");
   if (PrnSet&0x01) { Message_Text (&New_Page); PrnSet|=0x10; }
   if (PrnSet&0x04) { // Page number
    k=Wides[Flag_Prn]/2-4;
    for (j=0;j<k; j++) fprintf (Printfile,"%c",' ');
    fprintf (Printfile," %-3d \n",page); strnum++;
   }
   if (PrnSet&0x08) {  // Upper border
    PrintLine (Printfile,0x00,How[Flag_Prn],Kol[Flag_Prn]); strnum++; PrnSet|=0x80;
   }
  }

  if (Flag_Prn==0x00) {
   if (Ind==Len_Data) break;
   k=fprintf (Printfile,Fmt[0],Ind+1,Data_Array.X[Ind],Data_Array.Y[Ind]);
  }

  else if (Flag_Prn==0x01) {
   if (Ind==Spline_Len) break;
   k=fprintf ( Printfile,Fmt[1],Ind+1,Spline_Array.X[Ind],Spline_Array.Y[Ind],
      DS1(Spline_Array.X[Ind]),DDS1(Spline_Array.X[Ind]) );
  }
  else {
   if (Ind==Rep_Len) break;
   Report_View (0,0,Ind); fprintf ( Printfile,"\n");
   k=1;
  }
//  if ((!k) && (PrnSet&0x40)) {
//   if( !Answ_Menu( &Prn_Error ) ) continue;
//   else goto PRN_OUT;
//  }
  strnum++;
 }
 if (PrnSet&0x08) { // Border
  PrnPage++;
  if (PrnSet&0x80){ PrnSet&=0x7f; PrintLine (Printfile,0x02,How[Flag_Prn],Kol[Flag_Prn]); }
 }
 if (PrnSet&0x40) Message_Text( &Prn_Ok );
PRN_OUT:
 fclose (Printfile); return;
}

void PrintLine(FILE  *fptr,MODE Line,int Num,int far *Kol) {
 int i,j,k=0;  MODE done=0x00;
 MODE Sym[3][3]={ {'','',''},{'','',''},{'','',''} };
 fprintf (fptr,"%c",Sym[Line][0]);
 for (i=0; i<Num; i++) {
  if (!done) k=*(Kol+i);
  if (k<0) { done=0x01; k=-k; }
  for (j=0;j<k;j++) fprintf (fptr,"%c",'');
  if (i<Num-1) fprintf (fptr,"%c",Sym[Line][1]);
 }
 fprintf (fptr,"%c\n",Sym[Line][2]);
 return;
}

/////////////////////////////////////////////////////////////////////////
void Show_Data( SHOW_RECORD *record ) {
 KEY Bar_Keys[3]={ESC,PAGE_UP,PAGE_DO};
 int Pos_Keys[4]={15,103,223,343};
 char Num_Keys=3;
 int i,j,met = 0,
  tr  = 4*_fstrlen( record->Title ),
  beg_ti = record->X1 - tr +((record->X2-record->X1)>>1);
 KEY sim=0;
 Tmp = record;
 Loc = 0;
 Show_X1 = record->X1; Show_Y1 = record->Y1;
 Show_X2 = record->X2; Show_Y2 = record->Y2;
 Kol = Show_Y1+24+10*record->Kol_String;
 Hi_Data  = (Show_Y2 - Show_Y1)/11-(4+record->Kol_String);
 Paint = record->Text_View;

 CURSOR_OFF();
 setfillstyle( SOLID_FILL, LIGHTCYAN );
 bar( Show_X1, Show_Y1, Show_X2, Show_Y2 );
 setcolor( BLACK );
 rectangle( Show_X1+2, Show_Y1+2, Show_X2-2, Show_Y2-2 );
 rectangle( Show_X1+4, Show_Y1+4, Show_X2-4, Show_Y2-4 );
 setfillstyle( SOLID_FILL, BLACK );
 bar( beg_ti-5, Show_Y1+4, beg_ti+5+8*_fstrlen( record->Title ), Show_Y1+15 );
 setcolor( WHITE );
 outtextxy( beg_ti, Show_Y1+6, record->Title );
 setfillstyle( SOLID_FILL, YELLOW );
 bar( Show_X1+8, Show_Y1+18, Show_X2-8, Kol );
 setcolor( BLACK );
 rectangle( Show_X1+8, Show_Y1+18, Show_X2-8, Kol );
 CURSOR_ON();
 Fun_Bar((char far *)"$ESC$ 室  $PAGE UP$   $PAGE DOWN$ ");
 Print( Show_X1+20, Show_Y1+20, BLACK, BLACK, *record->Names_Tabl );
 for( i = 1; i < record->Kol_Punct; i++ ) {
  Print( Show_X1+20+(*(record->Line+i-1)), Show_Y1+20, BLACK, BLACK,
	    *(record->Names_Tabl+i) );
 }
 //    -1 - Show report
 //	0 - Show data   1 - Show spline  2 - Edit data  3 - Edit knots
 //     4 - Apriory info
 if (Type==-1) Lendata=RealLen();
 else if ((Type+2)%2)  Lendata = Spline_Len; // cases 1,3
 else  Lendata = Len_Data;                   // cases 0,2,4

 if (Lendata< Hi_Data)  Hi_Data = Lendata;
 if (Type<2) Pos=0;
 List_Variable( Pos );
 Sound(3500,10);
 while ( 1 ) {
AGAIN:
  Chand(Show_X1+14,Kol+7+Loc*11,Show_X2-14,Kol+17+Loc*11,SHOW_COLOR,XORI);
  if (Mouse) while (!Hit_Key()) {
   ms_state ();
   if (buttons==0x01) { //Left
    if (Fun_Bar_Keys (Num_Keys,Bar_Keys,Pos_Keys)) goto KEYBOARD;
    if (Mouse_In_Field (Show_X1+14,Kol+7,Show_X2-Show_X1-28,11,1,Hi_Data+1,0,0,
     SHOW_COLOR,&i,&j)) {
      Chand(Show_X1+14,Kol+7+Loc*11,Show_X2-14,Kol+17+Loc*11,SHOW_COLOR,XORI);
      Loc=j; goto AGAIN;
    }
   }
  }
KEYBOARD:  sim=Get_Key();
  Chand(Show_X1+14,Kol+7+Loc*11,Show_X2-14,Kol+17+Loc*11,SHOW_COLOR,XORI);
  switch( sim ) {
   case ESC: goto OUT;
// case PSEUDO: List_Variable(met); break;
   case DOWN :
    if ( met < Lendata ) {
     if ( Loc == Hi_Data ) {
      if ( met != Lendata-1 ) List_Variable( (++met)-Hi_Data );
     }
     else {      Loc++; met++;     }
    }
   break;
   case UP:
    if( met ) {
     if( !Loc ) { List_Variable( (--met) ); }
     else {      Loc--; met--;     }
    }
    break;
   case PAGE_UP:
    if( (met -= Hi_Data) > 0 ) {
     if (met < Hi_Data)  Loc=met;
     List_Variable( ((met>Loc)? met-Loc: 0) ); }
    else {
     Loc = met = 0;
     List_Variable( met );
    }
    break;
   case PAGE_DO:
    if( (met += Hi_Data) < Lendata ) List_Variable( met-Loc );
    else {
     Loc = Hi_Data;
     met = Lendata-1; if (Lendata==Hi_Data) met++;
     List_Variable( met-Hi_Data );
    }
   break;
   case CTRL_UP : met = 0; Set_Key( 1, PAGE_UP ); break;
   case CTRL_DO : met = Lendata; Set_Key( 1, PAGE_DO ); break;
  } // switch
 }; // while
OUT:
 if (Type<2) {
  setcolor( LIGHTCYAN ); CURSOR_OFF();
  rectangle( Show_X1+2, Show_Y1+2, Show_X2-2, Show_Y2-2 );
  rectangle( Show_X1+4, Show_Y1+4, Show_X2-4, Show_Y2-4 );
 } CURSOR_ON(); return;
}

void List_Variable ( int pos ) {
 int j,i = Hi_Data;
 if( pos+i >= Lendata ) i = Lendata - pos - 1;
 CURSOR_OFF();
 setfillstyle( SOLID_FILL, LIGHTCYAN );
 bar( Show_X1+9, Kol+5, Show_X2-9, Show_Y2-8 );
 CURSOR_ON();
 for( j = 0; j <= i; pos++, j++ ) Paint( Show_X1+14, Kol+8+j*11, pos );
 setcolor( BLACK ); CURSOR_OFF();
 for( j = 1; j < Tmp->Kol_Punct; j++ ) {
  i=Show_X1+(*(Tmp->Line+j-1));
  line( i , Show_Y1+18, i , Show_Y2-8 );
 } CURSOR_ON();
 return;
}

//////////////////////////////////////////////////////////////////////
int RealLen(void) {
 int RetLen=0,i,j;
 switch (Rep&0x03) {
  case 0x00:
   if (tabl17[0].zam) RetLen=Len_Data;
   else RetLen=DataPlusSpline(0,&i,&j);
  break;
  case 0x01: RetLen=Len_Data; break;
  case 0x02: RetLen=Spline_Len; break;
  default:   RetLen=DataPlusSpline(0,&i,&j); break;
 }
 return (RetLen);
}

int DataPlusSpline (int To,int far *d,int far *s) {
 // To==0 - Scan all, else - scan fot To-number and return s and d;
 int all=0; float spl,dat;
 (*d)=0; (*s)=0;
 for (;;) {
  dat=Data_Array.X[(*d)];  spl=Spline_Array.X[(*s)];
  if (dat==spl) { (*s)++; (*d)++; }
  else if (dat>spl) (*s)++;
  else (*d)++;
  all++;
  if ((To) && (all==To)) return (all);
  if ((*d)==Len_Data) { all+=Spline_Len-(*s); break; }
  if ((*s)==Spline_Len) { all+=Len_Data-(*d); break; }
 }
 return (all);
}

void Report (void) {
 Set_Key( 2, ESC, START );
 Ext_Function = Show_R;
 RepTo=0x01; //File
}

void Beg_Report (void) {
 Set_Key( 2, ESC, START );
 Ext_Function = Show_R;
 RepTo=0x00; //Screen
}

void Show_R(void) { // ⠭  ﭨ  - Rep
 datar.Kol_Punct=1; vr[0]=vstr[0];
 if (tabl9[0].color1==1 || tabl9[0].zam==0) Rep=0x00; //  . .  -樨
 else { vr[1]=vstr[1]; Rep=0x01; datar.Kol_Punct=2; }
 if (tabl17[0].zam==0) { //   㧫 .㭪樨
  if (tabl9[1].color1!=1 && tabl9[1].zam!=0)  { // 窨 
   Rep|=0x02; vr[datar.Kol_Punct]=vstr[2]; datar.Kol_Punct++;
  }
 }
 if (tabl9[2].color1!=1 && tabl9[2].zam!=0) {  // . 祭
   vr[datar.Kol_Punct]=vstr[3]; datar.Kol_Punct++; Rep|=0x04;}
 if (tabl9[3].color1!=1 && tabl9[3].zam!=0) {  // Spline
   vr[datar.Kol_Punct]=vstr[4]; datar.Kol_Punct++; Rep|=0x08;}
 if (tabl13[0].zam==0 && tabl9[4].color1!=1 && tabl9[4].zam!=0) {
   //  離  ᣫ.ᯫ
   vr[datar.Kol_Punct]=vstr[5]; datar.Kol_Punct++;  Rep|=0x10; }
 if (tabl9[5].color1!=1 && tabl9[5].zam!=0) {  // 1-st deriv.
   vr[datar.Kol_Punct]=vstr[6]; datar.Kol_Punct++;  Rep|=0x20; }
 if (tabl9[6].color1!=1 && tabl9[6].zam!=0) {  // 2-nd deriv.
   vr[datar.Kol_Punct]=vstr[7]; datar.Kol_Punct++; Rep|=0x40; }
 if (tabl9[7].color1!=1 && tabl9[7].zam!=0) Rep|=0x80; // .ଠ
 datar.Names_Tabl=vr; dpos=spos=0;
 switch (RepTo) {
  case 0x00: Type=-1; Show_Data(&datar); Type=0; break;     // Screen
  case 0x01: Report_File(); break;                          // File
  case 0x02: break;                                         // Printer
 }
 return;
}

void Report_File(void) {
 CASE Rep_Ok = { 218,100,440,155,14,12,0,"",
 " ନ஢  䠩&             ",Nop };
 MODE PrnSave;
 char far *PointPtr; int i;
 PrnSave=PrnSet; PrnSet&=0x0A; // 0000 x0x0
 _fstrcpy (Printname,File_Name);
 i=min(_fstrlen(Printname),8);
 PointPtr=_fstrchr (Printname,'.');
 if (PointPtr==NULL) { Printname[i]='.'; PointPtr=&(Printname[i]); }
 PointPtr++;
 _fstrncpy (PointPtr,"rep",3); *(PointPtr+3)='\0';
 Flag_Prn=0x02; Print_Data();
 if (What&0x80) What&=0x7f; //No
 else { // OK
  _fstrncpy (&(Rep_Ok.help[26]),Printname,13);
  Message_Text (&Rep_Ok);
 }
 PrnSet=PrnSave; _fstrcpy (Printname,"prn");
 return;
}

void Report_View (int x,int y,const  int pos ) {
 // 뢥 ப 
 char far *Fmt="%-9.4f",far *Fmt0="%-9.4f",
      far *Void=" ",far *VoidFmt="%9s";
 float Point,Y0,Y;
 int step=84;
 if (y==Kol+8) { // 1st line on the screen
  switch (Rep&0x03) {
   case 0x01: dpos=pos; break;
   case 0x02: spos=pos; break;
   default:
    if (pos>0) DataPlusSpline (pos,&dpos,&spos); // set positions in arrays
    else dpos=spos=0;
   break;
  }
 }
 if (RepTo) {
  if (PrnSet&0x08) fprintf (Printfile,"%-4d",pos+1);
  else {
   fprintf (Printfile," %-4d ",pos+1); Fmt0[6]=' '; VoidFmt[3]=' ';
  }
 }
 else { Gprintf( x, y,"%-4d",pos+1); x+=55; }
 Point=Data_Array.X[dpos];  Y=Spline_Array.X[spos]; Y0=Data_Array.Y[dpos];
 Where|=0x80;
 switch (Rep&0x03) { //  饭 ᮢ
  case 0x01: dpos++; break;
  case 0x02: spos++; Point=Y; break;
  default:
   if (tabl17[0].zam) dpos++;
   else {
    if (Point==Y) { spos++; dpos++;  }
    else if (Point>Y) { spos++; Where&=0x7f; Point=Y; }
    else dpos++;
   }
  break;
 }
 if (Rep&0x01) {
  if (RepTo) {
   if (Where&0x80) fprintf (Printfile,Fmt0,Point);
   else fprintf (Printfile,VoidFmt,Void);
  }
  else {  if (Where&0x80) Gprintf( x, y, Fmt, Point);    x+=step;  }
 }
 if (Rep&0x02) {
  if (RepTo) fprintf (Printfile,Fmt0,Point);
  else {  Gprintf( x, y,Fmt,Point);   x+=step;  }
 }
 if (Rep&0x04) {  // 窠 
  if (RepTo) {
   if (Where&0x80) fprintf (Printfile,Fmt0,Y0);
   else fprintf (Printfile,VoidFmt,Void);
  }
  else {  if (Where&0x80) Gprintf( x, y,Fmt, Y0); x+=step; }
 }
 if (Rep&0x08) {  // 祭
  Y=S1( Point );
  if (RepTo) fprintf (Printfile,Fmt0,Y);
  else { Gprintf( x, y,Fmt, Y); x+=step; }
 }
 if (Rep&0x10) { // 離
  Y=S1(Point);
  if (RepTo) {
   if (Where&0x80) fprintf (Printfile,Fmt0,Y-Y0);
   else fprintf (Printfile,VoidFmt,Void);
  }
  else {  if (Where&0x80) Gprintf( x, y,Fmt, Y-Y0);   x+=step; }
 }
 if (Rep&0x20) {
  Y= DS1( Point );
  if (RepTo) fprintf (Printfile,Fmt0,Y);
  else { Gprintf( x, y,Fmt,Y ); x+=step; }
 }
 if (Rep&0x40) {
  Y=DDS1 (Point);
  if (RepTo) fprintf (Printfile,Fmt0,Y);
  else { Gprintf( x, y,Fmt,Y ); x+=step; }
 }
 return;
}

//////////////////////////////////////////////////////////////////////////
void Bilding( void )  {
 if (tabl17[0].zam) Get_Setka_Num(); // ⪠  .ᯫ  㬮砭
				     // Spline_Array.X  Spline_Array.Y
 What|=0x01;
 Renew_Rab();
 Set_Key( 2, ESC, START );
 Ext_Function = Begin_Bilding;
}

#define X1_SPL 124
#define X2_SPL 515
#define Y1_SPL 40
#define Y2_SPL 190

void Begin_Bilding( void ) {
 float cal;
 int Numsol,par14,par15;
 CASE Spline_Ok = { 193,85,447,145,14,12,0,"",
  "  ஥ ᯫ ᯥ譮&"
  "            襭",Nop },
      Time_Ok = { 193,125,447,165,14,12,0,"",
  "६   ᥪ.:        ",Nop };
 char far *smes[7]= {
  "ࠡ⪠ ࠥ ᫮       -",
  "ࠡ⪠ ࠬ ᣫ -",
  "ࠡ⪠ 祭 ᯥᨨ    -",
  "ࠡ⪠ 㬠 室   -",
  "஥ ᯫ              -",
  "஥ ࢮ ந   -",
  "஥ ன ந   -"
 };
 //char far *bm; unsigned ii;
 long time1,time2; // 砫   
 float ff; int i,err=0;

 if (tabl13[2].zam) { // ਯ⨢
  if (What&0x04) {
   What&=0xfb;  Renew_Dmat();
  }
  if (Apriory_Info()) return;
 }
// ii=imagesize( X1_SPL, Y1_SPL, X2_SPL+8, Y2_SPL+8 );
// bm=(char far *)farmalloc (ii);
// if (bm==NULL) Close_System();
 CURSOR_OFF();
// getimage( X1_SPL, Y1_SPL, X2_SPL+8, Y2_SPL+8, bm );
 setfillstyle( SOLID_FILL, YELLOW );
 bar( X1_SPL, Y1_SPL, X2_SPL, Y2_SPL );
 setcolor( BLACK );
 rectangle( X1_SPL+2, Y1_SPL+2, X2_SPL-2, Y2_SPL-2 );
 rectangle( X1_SPL+4, Y1_SPL+4, X2_SPL-4, Y2_SPL-4 );
 setfillstyle( SOLID_FILL, BLACK );
 bar( X1_SPL+((X2_SPL-X1_SPL)>>1)-48, Y1_SPL+4, X1_SPL+((X2_SPL-X1_SPL)>>1)+45, Y1_SPL+16 );
 setfillstyle( SOLID_FILL, BLACK );
 bar( X1_SPL+((X2_SPL-X1_SPL)>>1)-48, Y1_SPL+4, X1_SPL+((X2_SPL-X1_SPL)>>1)+45, Y1_SPL+16 );
 CURSOR_ON();
 Chand( X1_SPL+8, Y2_SPL+1, X2_SPL+8, Y2_SPL+8, DARKGRAY, ANDI );
 Chand( X2_SPL+1, Y1_SPL+5, X2_SPL+8, Y2_SPL,   DARKGRAY, ANDI );
 Print( X1_SPL+((X2_SPL-X1_SPL)>>1)-40, Y1_SPL+6, LIGHTRED, LIGHTRED, (char far *)"" );
 Fun_Bar( (char far *)" ஥ 㡨᪮ ᯫ..." );
 setcolor( BLACK );
 for (i=0;i<7;i++) Print( X1_SPL+20, Y1_SPL+30+15*i, BLACK, BLACK, smes[i]);
 setcolor( LIGHTRED );
 for (i=0;i<3;i++) Print( X1_SPL+300, Y1_SPL+30+15*i, LIGHTRED, LIGHTRED,(char far *)"");
 time1=biostime (0,0L);
 if( tabl13[0].zam ) /* ௮樮 ᯫ */  {
  smuik_ ( &Len_Data, Data_Array.X, Data_Array.Y, &Left_Kr_Param,
	 &Right_Kr_Param, &Left_Value, &Right_Value, &Rab[0], &err );
  if (err) goto Error;
  else Print( X1_SPL+20+35*8, Y1_SPL+75, LIGHTRED, LIGHTRED, (char far *)"" );
 }
else {
  // । ᯥᨨ
  epsv=Disp;
  smuvar ( &Len_Data, Data_Array.Y, V, P, &epsv, &Disp, &Disp_Param,
	   &mid_disp, &Rab[0]);
  Print( X1_SPL+20+35*8, Y1_SPL+75, LIGHTRED, LIGHTRED,(char far *)"" );
  Al_0 = All;
  Lseg = Len_Data>>2;
 if (tabl13[1].zam) { /* 騩 */
  switch( Vid_Param ) {
   case 1: {    //.  .ࠬ ᣫ.
    smukf_( &Len_Data, Data_Array.X, Data_Array.Y, P,
	   &Left_Kr_Param, &Right_Kr_Param, &Left_Value,
	   &Right_Value, &Al_0, &Rab[0], &err );
   break; }
   case 2: {
    chal = -1;  //.   ..訡;.-
    smukv1_( &Len_Data, Data_Array.X, Data_Array.Y, P, V,
	    &Left_Kr_Param, &Right_Kr_Param, &Left_Value,
	     &Right_Value, &chal, &All, &Rab[0], &err ); // Smukv.cpp;Call smualu_
   break; }
   case 3: {
    chal = 0.8;  //.   ..訡;.離
    smukv1_( &Len_Data, Data_Array.X, Data_Array.Y, P,V,
	    &Left_Kr_Param, &Right_Kr_Param, &Left_Value,
	    &Right_Value, &chal, &All, &Rab[0], &err );
   break; }
   case 4: {  //  .஢ 㬠
    All  = -1.;
    smukn1_( &Len_Data, Data_Array.X, Data_Array.Y, P,
	    &Left_Kr_Param, &Right_Kr_Param, &Left_Value,
	    &Right_Value, &Lseg, &All, &Rab[0], &err ); //smuknn.cpp
   break; }
   case 5: { //.   筮 -
    //⠭  ࠬ Numsol
    if (tabl31[0].zam) /* ਭ*/ Numsol=2;
    else /*.।*/ Numsol=1;
    // ⠥ .ᣫ.ᯫ  筮 -
    All=-1.0;  par15=0; par14=1;
    smuks1_ (&Len_Data,Data_Array.X,Data_Array.Y,P,
     &Left_Kr_Param,&Right_Kr_Param,&Left_Value,&Right_Value,&All,
     &Ideriv,&Numsol,&Wide,&Usv,&par14,&par15,&Rab[0],&err); //smusin.cpp
   } break;
  } // switch
 } // else
 else { // ਯ⨢
  cal=1.0; // ४஢ ࠬ ᣫ
  chal=0.; //  What|=0x02; //   !!!
  switch( Vid_Param ) {
   case 1: //. .ࠬ ᣫ.
   altype=2;  break;
   case 2: //.-
    chal = -1; altype=0; break;
   case 3: //.離
    chal = 0.8; altype=0; break;
   case 4: //⮤ ४. 稬
    All  = -1.; altype=1; break;
   default: // 筮 ࠪ⨪
    if (tabl31[0].zam) /* ਭ*/ Numsol=2;
    else /*.।*/ Numsol=1;
    All=-1.0;  par15=0; par14=1;
    smuks1_ (&Len_Data,Data_Array.X,Data_Array.Y,P,
     &Left_Kr_Param,&Right_Kr_Param,&Left_Value,&Right_Value,&All,
     &Ideriv,&Numsol,&Wide,&Usv,&par14,&par15,&Rab[0],&err); //smusin.cpp
   altype=2;  break; //  ⠥,  ࠬ ᣫ 
  }
  smdkvnf_ (&Len_Data, Data_Array.X, Data_Array.Y, P, V,
   &Left_Kr_Param,&Right_Kr_Param,&Left_Value,&Right_Value,&Nrec,
   &DmatPtr[0],&Dvec2[0],&chal,&Lseg,&All,
   &cal,&Rab[0],&altype, &err); //smdebaz1.cpp
  for (i=Nrec-1; i>=0; i--) { // ⠭ 砫  . -樨
   par15=(int)DmatPtr[3*Len_Data+i];
   if (par15!=-1) {
    for (par14=0; par14<3; par14++)
     DmatPtr[3*par15+par14]=DmatPtr[3*i+par14];
    DmatPtr[3*Len_Data+par15]=(float)par15;
    Dvec[par15]=Dvec[i];
    if (i!=par15) {
     DmatPtr[3*i]=Data_Array.X[i];
     DmatPtr[3*i+1]=0.0; DmatPtr[3*i+2]=0.0;
     DmatPtr[3*Len_Data+i]=-1.0;
     Dvec[i]=0.0;
    }
   }
  }
// What&=0xfd; // ⠭ ﭨ ஥ ᯫ
 }
 Al_N=All;
}
 Fun_Bar( (char far *)"" );
 Error:
 if (err!=0) Mistake (err);
 else {
  time2=biostime (0,0L);
  for (i=0;i<3;i++) Print( X1_SPL+300,Y1_SPL+90+15*i, LIGHTRED, LIGHTRED,(char far *)"");
  // (+) 䨪, ந (tabl10)   (tabl9)
  tabl10[ 1 ].color1 = tabl10[ 2 ].color1 = tabl10[ 3 ].color1 =
  tabl10[ 4 ].color1 =
  tabl9[ 3 ].color1  =  tabl9[ 5 ].color1  = tabl9[ 6 ].color1  =
  tabl9[ 7 ].color1  = 14;
  tabl9[1].color1 =(tabl17[0].zam ? 1 :14);        //  
  tabl9[ 4 ].color1 = tabl9[ 2 ].color1 =((tabl13[0].zam) ? 1 : 14 );
						  // 離  .-樨
  // (+) . 
  tabl1[ 2 ].color1 = 0;  tabl1[ 2 ].color2 = 12;
	// (+) ਭ._ᯫ  ,.ࠪ⨪, 
  tabl2[1].color1  = tabl2[2].color1  = tabl6[1].color1= tabl6[2].color1= 0;
  tabl2[1].color2  = tabl2[2].color2= tabl6[1].color2= tabl6[2].color2= 12;
  if (tabl13[1].zam) /* */ {
   tabl33[1].color1=tabl33[2].color1=14;tabl33[1].color2=tabl33[2].color2=12;}
  else {
   tabl33[1].color1=tabl33[2].color1=1;tabl33[1].color2=tabl33[2].color2=1;}
  // 樠஢ ᨢ 祪
  for (i=0;i < Spline_Len; i++) {
   ff=Spline_Array.X[i];
   Spline_Array.Y[i] = S1 (ff);
  }
  if (tabl12[3].zam) Thank|=0x12;
  Message_Text( &Spline_Ok );
  if (tabl12[3].zam) { // Time statistics
   difftime_=(float)((time2-time1)/18.2);
   sprintf (&(Time_Ok.help[20]),"%-6.3f",difftime_);
   Thank|=0x10;
   Message_Text (&Time_Ok);
  }
  Har=0x00;
 } CURSOR_OFF();
// putimage( X1_SPL, Y1_SPL, bm, COPY_PUT );
// farfree( bm );
 CURSOR_ON();
 Clr_Scr(); //!!!
 return;
}

// Graph.cpp
void Plot_Graphic(int i);
void Put_Frame (void);
float Upround( float );
int Round( float );
void Process_Graphics(void);
void Print_Points (float far  *X,Table_Fun F,int  N,int Color);
int Interval(float X);
void Control_Range (float X);
float T (int ),T1 (int),N (int);
float S_ (float),DS_ (float),DDS_ (float ); //float S1( float ),DS1 ( float ),DDS1( float );
void Draw_Lines (int,int,int,int);

Graph_Param Param = {
 {  10,   9 },  // ﭨ   묨  ﬨ  窠
 {   5,   5 },  // ﭨ  訬 ﬨ  쪨
 {   5,   5 },  //   ࠧ⪨ न (."-"  ".")
 {   1,   1 },  // ᫮ ࠭ ᬮ  ࠢ
 {  19,  26 },  // 㣫 न ࠡ祣 
 { 610, 310 },
 { -30, -19 },  // ६ 祭 न
 {  65,  19 },
  0              //  ନ஢ 㭪樨
};

Graph_Fun_Param Fun_Param[6] =
 { { 0, 0, WHITE },
 { 0, 0, LIGHTRED },
 { 0, 0, LIGHTBLUE },
 { 0, 0, LIGHTGREEN },
 { 0, 0, LIGHTCYAN },
 { 0, 0, LIGHTMAGENTA }
}; // extern Graph_Fun_Param Fun_Param[];

int_plane  PO;       //  砫 न (0,0)
float_plane
   D,                               // 業 窨  न (⠡)
   Size,                            //  न   ࠭
   Min,Max;                         // ६ 祭 न  ⥪饬 
Graphics_Fun Fun[3] = {  S_,  DS_,  DDS_   };

int XX,YY,CC;
int Add;
int   Reg; float Norma;
float far  *Region,far  *AP,far  *BP,far  *CP,far  *DP;
int PX,PY;
int AddX,AddY;

///////////////////////////////////////////////////////////////////

void Spline_View(int x, int y,const  int pos ) {
 float f=Spline_Array.X[ pos ];
 Gprintf( x, y," %-4d       %- 9.5g    %- 9.5g    %- 9.5g    %- 9.5g",
	 pos+1, f, S1( f ), DS1( f ), DDS1( f ) );
 return;
}

// ᫥ 祭 ᯫ  窥 X १ Reg
float S1(float X) {
 float dx;           //(+) on (-)
 Reg=Interval(X);                  // 㦭   ࢠ ⪨
 AP=&Rab[     Reg];
 BP=&Rab[(Len_Data)   + Reg];      //   樥 童
 CP=&Rab[(Len_Data)*2 + Reg];
 DP=&Rab[(Len_Data)*3 + Reg];
 Region=&Data_Array.X[Reg];      // ⠪ 祭  㧫 ࢠ
 Control_Range(X);
 dx=X-*Region;
 return( ((*AP)+dx*((*BP)+dx*((*CP)+dx*(*DP)))) );
}

// ᫥ 祭 1- ந ᯫ  窥 X १ Reg
float DS1(float X) {
 float dx;    //(+) on (-)
 Reg=Interval(X);                  // 㦭   ࢠ ⪨
 AP=&Rab[    Reg];
 BP=&Rab[(Len_Data)   + Reg];      //   樥 童
 CP=&Rab[(Len_Data)*2 + Reg];
 DP=&Rab[(Len_Data)*3 + Reg];
 Region=&Data_Array.X[Reg];      // ⠪ 祭  㧫 ࢠ
 Control_Range(X);
 dx=X-*Region;
 return( ((*BP)+dx*(2*(*CP)+3*dx*(*DP))) );
}

// ᫥ 祭 2- ந ᯫ  窥 X १ Reg
float DDS1(float X) {
 Reg=Interval(X);                  // 㦭   ࢠ ⪨
 AP=&Rab[       Reg];
 BP=&Rab[(Len_Data)   + Reg];      //   樥 童
 CP=&Rab[(Len_Data)*2 + Reg];
 DP=&Rab[(Len_Data)*3 + Reg];
 Region=&Data_Array.X[Reg];      // ⠪ 祭  㧫 ࢠ
 Control_Range(X);   //(+) on (-)
 return( (2*(*CP)+6*(*DP)*(X-*Region)) );
}
///////////////////////////////////////////////////////////////////

float Upround (float R) {
   return( (R<0) ? floor(R) : ceil(R) ); }

int Round (float R) {
   return( (int)( R+ ((R<0) ? -0.5 : +0.5 )) ); }

void Put_Frame (void) {
 int_plane
	C,             //  窨 祭 न ᥩ
	Den,           // ࠡ祥 祭 ࠬ Param.Densi
	Bsl;           // ࠡ祥 祭 ࠬ Param.Bs

 int     Add;
 direct  Dir;
 int     I,P,Len,Lim;
 float   R;
 char   Lin[12]; char *L1,*L2;
 R = Min[Ver];      Min[Ver]=Max[Ver];         Max[Ver]=R;
 for ( Dir=Hor; Dir<=Ver; Dir++) {
  R = fabs(Min[Dir]);
  if( R < fabs(Max[Dir]) )
  R = fabs(Max[Dir]);
  itoa( Upround( R ), Lin, 10 );
  I=strlen( Lin ) + 2;
  Bsl[Dir]=Param.Bs[Dir]*Param.Ls[Dir];    // 訥   窠
  while( I*8>=Bsl[Dir] )  Bsl[Dir]+=Param.Ls[Dir];
  Den[Dir]=Param.Densi[Dir]-I; // ᫮  ᫥ ⮩  ࠧ⪥ न
  if( Den[Dir]<0 )  Den[Dir]=0;
  if (Max[Dir]!=Min[Dir]) // ﭨ  訬 ﬨ  न
   R=(Max[Dir]-Min[Dir])*Bsl[Dir]/(Param.P2[Dir]-Param.P1[Dir]);
  else
    R=(R!=0)?(-4*R*Bsl[Dir]/(Param.P2[Dir]-Param.P1[Dir])):1;
/*if( Den[Dir] == 0 ) R=Upround(R);// 饭   筮
  for (I=2;I<=Den[Dir];I++) R*=10;
  R=Upround(R*2)/2;
  for (I=2;I<=Den[Dir];I++) R/=10;
*/
  D[Dir]=R/Bsl[Dir];                       //  窨  न
  if( Min[Dir] == Max[Dir] ) R=(Param.P1[Dir]+Param.P2[Dir]) >> 1;
  else R=(Param.P1[Dir]*Max[Dir]-Min[Dir]*Param.P2[Dir])/(Max[Dir]-Min[Dir]);
  PO[Dir]=Round(R);  //  砫 न
 }
 R=Min[Ver];        Min[Ver]=Max[Ver];         Max[Ver]=R;
 if( PO[Hor]<Param.P1[Hor]+Bsl[Hor] ) C[Hor]=Param.P1[Hor]+Bsl[Hor];
 else if( PO[Hor]>Param.P2[Hor]-25 )  C[Hor]=Param.P2[Hor]-25;                //  窨 祭 ᥩ
 else   C[Hor]=PO[Hor];
 if( PO[Ver]<Param.P1[Ver]+22 ) C[Ver]=Param.P1[Ver]+22;
 else if( PO[Ver]>Param.P2[Ver]-22 ) C[Ver]=Param.P2[Ver]-22;
 else  C[Ver]=PO[Ver];
 for (Dir=Hor;Dir<=Ver;Dir++)  {    // ࠢ 窨 祭 ᥩ
  I=(PO[Dir]-C[Dir]) % Bsl[Dir];
  if( C[Dir]>((Param.P2[Dir]-Param.P1[Dir]) >> 1 ) ) {  // 蠥 C
   if( C[Dir]<PO[Dir] )  C[Dir]=C[Dir]-Bsl[Dir]*((I==0)?0:1);
  }
   else                                     // 稢 C
   if( C[Dir]>PO[Dir] )
    C[Dir]=C[Dir]+Bsl[Dir]*((I==0)?0:1);
  C[Dir] +=I;
 }
 CURSOR_OFF();
 setcolor(AxisColor);
 setfillstyle( SOLID_FILL, BLACK );
 line(Param.P1[Hor],C[Ver],Param.P2[Hor],C[Ver]);         //  न
 line(C[Hor],Param.P1[Ver],C[Hor],Param.P2[Ver]);
 Dir=Hor;   Add=-1;   Lim=-Param.P1[Hor];
 do {                                         // ᥭ ࠧ⪨
  P=C[Dir];    R=(C[Dir]-PO[Dir])*D[Dir];     I=0;
  do {
   P+=Add*Param.Ls[Dir];                //   
   R+=Add*D[Dir]*Param.Ls[Dir];         // न ⭮⥫쭮 (0,0)
   I+=Param.Ls[Dir];                    // ᫮ 祪  祭 ᥩ
   if( (I % Bsl[Dir]) == 0 ) {
    if( Dir==Ver )  Len=6;              //  窠 ⨪쭮 
    else            Len=5;             //  窠 ਧ⠫쭮 
   }
   else	      Len=3;                           //  窠
   if( Dir==Hor ) line(P,C[Ver]-Len,P,C[Ver]+Len);
   else    line(C[Hor]-Len,P,C[Hor]+Len,P);
   if( Len>3 )  {                            // ନ㥬 ᫮
    int lim,s;    L2=Lin;
    L1=fcvt( R, Den[Dir], &lim, &s);
    if (s) *(L2++)='-'; // 
    if (lim) for (s=1; s<=lim; s++) *(L2++)=*(L1++);      //  
    else  *(L2++)='0';
    if (Den[Dir])  *(L2++)='.';                       // 窠
    for (s=1; s<=Den[Dir]; s++) *(L2++)=*(L1++); // ஡ 
    *(L2++)='\0';
    if( Dir==Hor ) moveto(P-strlen(Lin)*4+1,C[Ver]+10);
    else  moveto(C[Hor]-strlen(Lin)*8-10,P-3);
    setcolor(DigitColor);                 // 뢮 ࠧ⪨ न
    outtext(Lin);
    setcolor(AxisColor);
   }
  } while( Add*(P+Add*Param.Ls[Dir])<Lim );
  if( (Dir==Ver)&&(Add==1) )  Add=0;
  else   Add=-Add;
  if( Dir==Hor )  if( Add==1 )  Lim=Param.P2[Hor];
  else  Dir=Ver;
  if( Dir==Ver )  if( Add==1 )  Lim=Param.P2[Ver];
  else Lim=-Param.P1[Ver];
 } while( Add != 0 );
 if( (PO[Hor]==C[Hor])&&(PO[Ver]==C[Ver]) )    // 䨪 ᥩ
  outtextxy(C[Hor]-Param.Ls[Hor]-3,C[Ver]+Param.Ls[Ver]-3,(char far *)"O");
 outtextxy(C[Hor]+8,Param.P1[Ver],(char far *)"Y");
 outtextxy(Param.P2[Hor]-6,C[Ver]-14,(char far *)"X");
 CURSOR_ON(); return;
}

static void Put_Pixel1(void) {
 if( getpixel(XX,YY)==BLACK )  putpixel(XX,YY, CC);
 YY+=Add; return;
}

void Plot_Graphic (int i) {
 float X;
 int   YYM,YY2;
 Graphics_Fun    F;
 CC   = Fun_Param[i].Color;            //  뢮 䨪
 F    = Fun[i-1];                      // 뢮 㭪
 X    = (Param.P1[Hor]-PO[Hor])*D[Hor];// 砫쭠 न    X
 if (i<4) {                            //  ᯫ   ந
  Reg=Interval(X);                  // 㦭   ࢠ ⪨
  AP=&Rab[   Reg];
  BP=&Rab[(Len_Data)   + Reg];      //   樥 童, 
  CP=&Rab[(Len_Data)*2 + Reg];
  DP=&Rab[(Len_Data)*3 + Reg];
  Region=&Data_Array.X[Reg];      // ⠪ 祭  㧫 ࢠ
 }                    //(+) on (-)
 XX=Param.P1[Hor];
 YY=Round(PO[Ver]+F(X)/D[Ver]);       //    Y
 CURSOR_OFF();
 while( XX<Param.P2[Hor] ) {
  YYM=Round(PO[Ver]+F(X+D[Hor]/2)/D[Ver]); // ஬筠   Y
  if( YY==YYM  ) Add=0;
  else  {                                 //  饭  Y
   if ( YY>YYM  )  Add=-1;
   else  Add=1;
  }
  do {
   Put_Pixel1();
  } while( YY!=YYM );                     // 諨  ஬筮 窨
  if( Add==1   )  Put_Pixel1();          // ஬筠 窠 ᫥
  X+=D[Hor];       XX++;             // த    ᥫ ࠢ
  if( Add==-1 )   Put_Pixel1();         // ஬筠 窠 ࠢ
  YY2=Round(PO[Ver]+F(X)/D[Ver]);          //    Y
  if( YY2==YYM )   Add=0;
  else    {                           //  饭  Y
   if( YY2>YYM ) Add=1;
   else  Add=-1;
  }
  YY=YYM+Add;                              // 諨  ஬筮 窨
  while( YY!=YY2 ) Put_Pixel1(); // 諨  ᫥饩 窨- ⥯ ⥪
 }
 Put_Pixel1();                               // ᫥ 窠
 CURSOR_ON();
 return;
}

static void Put_Pixel2(void) {
 PX+=AddX;  PY+=AddY;
 if( getpixel(PX,PY)==BLACK )  putpixel(PX,PY,CC);
 return;
}

void Print_Points (float far  *X,Table_Fun F,int  N,int Color) {
 int  I,XX,YY; //  KEY     sim;
 CC = Color;
 setcolor(Color);
 CURSOR_OFF();
 for (I=0;I<N;I++) { // ॡ 祪
  XX = Round( PO[Hor]+X[I]/D[Hor] );       //  ⥪饩 窨
  YY = Round( PO[Ver]+F(I)/D[Ver] );
  AddX=AddY=1;                             // 㥬 
  do {
   PX=XX;  PY=YY;
   Put_Pixel2();  Put_Pixel2();
   PY-=AddY;
   Put_Pixel2();  Put_Pixel2();
   AddX=-AddX;
   if( AddX==1 )  AddY=-AddY;
  } while( (AddX !=1) || (AddY !=1) );
  AddX=AddY=0;
  PX=XX;
  for( PY=YY-4; PY<=YY+4; PY++)  Put_Pixel2();
  PY=YY;
  for( PX=XX-5; PX<=XX+5; PX++)  Put_Pixel2();
 }
 CURSOR_ON(); return;
}

void Process_Graphics(void) {
 static char far *Str="  ᫮ ࠭ ᬮ& 䨪 (楫  0  20)";
 static KEY Alt_[3] = { ALT_X, ALT_Y, 0 };
 static char far Str1[4],far Str2[4];
 VIDI   opr = { 178, 70, 420, 240, 0x22,
  " ᫮ ࠭ & ஥ 䨪:",Alt_ };
 CASEI  tabl[2] = {
  { 20,0,228,50, 28, 10,0,
    "࠭  $X$:",294,20,70, Str1, Str, Nop },
  { 20,50,228,100, 28, 10,0,
    "࠭  $Y$:", 294,20,70,Str2,Str,Nop }
  };
 KEY Ch; int numx,numy,i,Id; float a,b;
 char far *Bar="$ESC$ 室  $UP$ \030  $DOWN$ \031  $LEFT$ \033  $RIGHT$ \032  $F10$ ⠡";
 KEY Bar_Keys[6]={ESC,UP,DOWN,LEFT,RIGHT,F10};
 int Pos_Keys[7]={15,103,151,215,279,351,447};
 char Num_Keys=6;

 // ४஢ ࠬ஢
 Size[Hor]=(Param.Maxim[Hor]-Param.Minim[Hor])/Param.Par[Hor];
 Size[Ver]=(Param.Maxim[Ver]-Param.Minim[Ver])/Param.Par[Ver];
 //  न   ࠭
 numx=numy=1;
 Min[Hor]=Param.Minim[Hor]; // ⠭  孥 ࠭
 Min[Ver]=Param.Maxim[Ver]-Size[Ver];
 Max[Hor]=Param.Minim[Hor]+Size[Hor];
 Max[Ver]=Param.Maxim[Ver];
 Fun_Bar(Bar);


 do{ // Processing
  // O   ᮢ ⪨ ࠭
  Draw_Lines (Param.Par[0],Param.Par[1],numx,numy);
  // 뢥    䨪
  Put_Frame();
  for (i=0;i<5;i++) if (tabl10[i].color2) {
   a=fabs(Fun_Param[i].Max);
   b=fabs(Fun_Param[i].Min);
   Norma = ( (Param.Norm) ? ( ( a > b ) ? a : b ) : 1. );// -ଠ 㭪樨
   if (Norma==0.) Norma=1.; // !!! BUG
   switch (i) {
    case 0:
     if (tabl17[0].zam) //  . 㭪樨
      Print_Points (Data_Array.X,T,Len_Data,Fun_Param[0].Color);
     else Print_Points (Spline_Array.X,T1,Spline_Len,Fun_Param[0].Color);
    break;
    case 4:
     Print_Points (Data_Array.X,N,Len_Data,Fun_Param[4].Color-1);
    break;
    default: Plot_Graphic(i); break;
   }
  }
  Sound(3500,10);
  do {
   if (Mouse) while (!Hit_Key()) {
    ms_state ();
    if (buttons==0x01) { //Left
     if (Fun_Bar_Keys (Num_Keys,Bar_Keys,Pos_Keys)) goto KEYBOARD;
    }
   }
KEYBOARD: Ch=Get_Key();
   switch (Ch) {
    case ESC: return;
    case LEFT:
     //if( Min[Hor]>Param.Minim[Hor] ) {
     if (numx>1) {
      Min[Hor]=Min[Hor]-Size[Hor];
      Max[Hor]=Max[Hor]-Size[Hor]; numx--; Ch=Exit_Key;
     }
    break;
    case RIGHT:
     //if ( Max[Hor]<Param.Maxim[Hor] )  {
     if (numx<Param.Par[0]) {
      Min[Hor]=Min[Hor]+Size[Hor];
      Max[Hor]=Max[Hor]+Size[Hor]; numx++; Ch=Exit_Key;
     }
    break;
    case UP:
     //if ( Max[Ver]<Param.Maxim[Ver] ) {
     if (numy>1) {
      Min[Ver]=Min[Ver]+Size[Ver];
      Max[Ver]=Max[Ver]+Size[Ver]; numy--; Ch=Exit_Key;
     }
    break;
    case DOWN:
     //if( Min[Ver]>Param.Minim[Ver] ) {
     if (numy<Param.Par[1]) {
      Min[Ver]=Min[Ver]-Size[Ver];
      Max[Ver]=Max[Ver]-Size[Ver]; numy++; Ch=Exit_Key;
     }
    break;
    case HOME:
     if (Param.Par[0]>1 || Param.Par[1]>1) {
      Min[Hor]=Param.Minim[Hor];
      Min[Ver]=Param.Maxim[Ver]-Size[Ver];
      Max[Hor]=Param.Minim[Hor]+Size[Hor];
      Max[Ver]=Param.Maxim[Ver]; numx=numy=1; Ch=Exit_Key;
     }
    break;
    case END:
     if (Param.Par[0]>1 || Param.Par[1]>1) {
      Min[Hor]=Param.Maxim[Hor]-Size[Hor];
      Min[Ver]=Param.Minim[Ver];
      Max[Hor]=Param.Maxim[Hor];
      Max[Ver]=Param.Minim[Ver]+Size[Ver];
      numx=Param.Par[0]; numy=Param.Par[1]; Ch=Exit_Key;
     }
    break;
    case F10: {
     itoa (Param.Par[0],Str1,10); itoa (Param.Par[1],Str2,10);
     Get_Many_Text (&opr,tabl);
     Fun_Bar(Bar);
     if ((Thank&0x0c)==0x0c) {
      Id=atoi(Str1);
      if (Id<=0 || Id>20) Mistake (121);
      else Param.Par[0]=Id;
      Id=atoi(Str2);
      if (Id<=0 || Id>20) Mistake (121);
      else Param.Par[1]=Id;
      Set_Key (2,ENTER,ENTER);
      return;
     }
    }
    case PAGE_UP:
     if (Param.Par[1]>1) {
      Min[Ver]=Param.Maxim[Ver]-Size[Ver];
      Max[Ver]=Param.Maxim[Ver];   numy=1; Ch=Exit_Key;
     }
    break;
    case PAGE_DO:
     if (Param.Par[1]>1) {
      Min[Ver]=Param.Minim[Ver];
      Max[Ver]=Param.Minim[Ver]+Size[Ver]; numy=Param.Par[1]; Ch=Exit_Key;
     }
    break;
    case CTRL_LEFT:
     if (Param.Par[0]>1) {
      Min[Hor]=Param.Minim[Hor];
      Max[Hor]=Param.Minim[Hor]+Size[Hor]; numx=1; Ch=Exit_Key;
     }
    break;
    case CTRL_RIGHT:
     if (Param.Par[0]>1) {
      Min[Hor]=Param.Maxim[Hor]-Size[Hor]; numx=Param.Par[0];
      Max[Hor]=Param.Maxim[Hor]; Ch=Exit_Key;
     }
    break;
    default: break;
   }
  } while ( Ch != Exit_Key );
 } while (1);
}

/* ᫥ 㬫 祭 㭪樨  㧫 Reg */
float T (int Reg) { // !!!
 return( Data_Array.Y[Reg]/Norma );
}
float T1 (int Reg) {
 return( Spline_Array.Y[Reg]/Norma );
}

/////////////////////////////////////////////////////////////////////
/* ஢ઠ  室 ᬥ   饭 祭 X */
void Control_Range (float X) {
 while ((Reg<Len_Data-2)&&(X>=Data_Array.X[Reg+1])) { //(+) on (-)
  Reg++; AP++; BP++; CP++; DP++; Region++;
 }
}

/*᫥ 祭 ᯫ  窥 X १ Reg */
float S_ (float X) {
 float dx;
 Control_Range(X);
 dx=X-*Region;
 return( ((*AP)+dx*((*BP)+dx*((*CP)+dx*(*DP))))/Norma );
}

/* ᫥ 祭 1- ந ᯫ  窥 X १ Reg */
float DS_ (float X) {
 float dx;
 Control_Range(X);
 dx=X-*Region;
 return( ((*BP)+dx*(2*(*CP)+3*dx*(*DP)))/Norma );
}

/* ᫥ 祭 2- ந ᯫ  窥 X १ Reg */
float DDS_ (float X) {
 Control_Range(X);
 return( (2*(*CP)+6*(*DP)*(X-*Region))/Norma );
}

/* ᫥ ࠧ 㬫 祭 㭪樨  ᯫ  㧫 Reg */
float N (int Reg) {
 return( (Data_Array.Y[Reg]-Rab[Reg])/Norma );
}

////////////////////////////////////////////////////////////////////////
/*    ⮤        㧫   0 <= l <= Len_Data-2
 ⪨, 㤮⢮饣 ᫮:  Array [ l ] <= X < Array [ l+1 ] */
int Interval(float X) {
 int l,r,m;  // left_bound, right_bound, middle
 l=0;    r=Len_Data-1;     m=(l+r)/2;
 while (l!=m) {                           // while (l!=r-1)
  if (X<Data_Array.X[m]) r=m;           // => X < Data_Array.X[r]
  else  l=m;                              // => Data_Array.X[l] <= X
  m=(l+r)/2;        //(+) on (-)
 }
 return (l);
}

//////////////////////////////////////////////////////////////////////////
//Paint.cpp
#define LINE1_X1  628
#define LINE1_Y1  26
#define LINE1_X2  639
#define LINE1_Y2  MAXY-27
#define STEP1     15

#define LINE2_X1  26
#define LINE2_Y1  MAXY-25
#define LINE2_X2  626
#define LINE2_Y2  MAXY-15
#define STEP2     15

void Graphics( void ) {
 int i; COLOR c[6];
 AP=&Rab[0];
 BP=&Rab[Len_Data];
 CP=&Rab[Len_Data*2];
 Param.Minim[0]= 1e10;
 Param.Maxim[0]=-1e10;
 Param.Minim[1]= 1e10;
 Param.Maxim[1]=-1e10;
 for (i=0; i<6; i++) {
  Fun_Param[i].Min= 1e10;
  Fun_Param[i].Max=-1e10;
  c[i]=tabl10[i].color2;
  if (tabl10[i].color2 && tabl10[i].color1!=14) tabl10[i].color2=0;
 }
 // ⠭ ࢠ  
 for ( i=0; i < Len_Data; i++)  {
  if ( Data_Array.X[i] < Param.Minim[ 0 ] ) Param.Minim[ 0 ] = Data_Array.X[i];
  if ( Data_Array.X[i] > Param.Maxim[ 0 ] ) Param.Maxim[ 0 ] = Data_Array.X[i];
  if ( tabl10[0].color2 ) { // 室 ᨬ
   if( Data_Array.Y[i] < Fun_Param[0].Min ) Fun_Param[0].Min = Data_Array.Y[i];
   if( Data_Array.Y[i] > Fun_Param[0].Max ) Fun_Param[0].Max = Data_Array.Y[i];
  }
  if (tabl10[1].color2) {   // -㭪
   if ( AP[i] > Fun_Param[1].Max ) Fun_Param[1].Max = AP[i];
   if ( AP[i] < Fun_Param[1].Min ) Fun_Param[1].Min = AP[i];
  }
  if (tabl10[2].color2) { // 1- ந
   if ( BP[i] > Fun_Param[2].Max ) Fun_Param[2].Max = BP[i];
   if ( BP[i] < Fun_Param[2].Min ) Fun_Param[2].Min = BP[i];
  }
  if (tabl10[3].color2) { // 2- ந
   if ( 2*CP[i] > Fun_Param[3].Max ) Fun_Param[3].Max = 2*CP[i];
   if ( 2*CP[i] < Fun_Param[3].Min ) Fun_Param[3].Min = 2*CP[i];
  }
  if (tabl10[4].color2)	{  // 
   if ( Data_Array.Y[i]-AP[i] > Fun_Param[4].Max )
	Fun_Param[4].Max = Data_Array.Y[i]-AP[i];
   if ( Data_Array.Y[i]-AP[i] < Fun_Param[4].Min )
	Fun_Param[4].Min = Data_Array.Y[i]-AP[i];
  }
 }
 for (i=0; i<6; i++) {
  if ( Fun_Param[i].Max > Param.Maxim[1] )
   Param.Maxim[1] = Fun_Param[i].Max;
  if ( Fun_Param[i].Min < Param.Minim[1] )
   Param.Minim[1] = Fun_Param[i].Min;
 }
 if (tabl10[2].color2 || tabl10[3].color2)  { // 䨪 ந -
  Param.Norm     = 1;               // ⮫쪮  ନ஢  (-1,1)
  Param.Maxim[1] = 1;
  Param.Minim[1] =-1;
 }
 else  Param.Norm = 0;
 Process_Graphics();
 CURSOR_OFF();
 setfillstyle( SOLID_FILL, BLACK );
 bar( 0, 12, 639, 26 );
 bar( 0, 12, 12, MAXY - 13 );
 bar( 625, 12, 639, MAXY - 13 );
 bar( 0, MAXY - 28, 639, MAXY - 13 );
 setcolor( WHITE );
 rectangle( 2,14,637,MAXY - 15 );
 CURSOR_ON();
 for (i=0; i<6; i++) tabl10[i].color2=c[i]; return;
}

/////////////////////
void Draw_Lines (int scrx,int scry,int numx,int numy) {
 int treg[4][6] = {
  { LINE1_X1+2, LINE1_Y1+STEP1-2, LINE1_X2-2, LINE1_Y1+STEP1-2,
    LINE1_X1+(LINE1_X2-LINE1_X1)/2, LINE1_Y1+2
  },
  { LINE1_X1+2, LINE1_Y2-STEP1+2, LINE1_X2-2, LINE1_Y2-STEP1+2,
    LINE1_X1+(LINE1_X2-LINE1_X1)/2, LINE1_Y2-2
  },
  { LINE2_X1+2, LINE2_Y1+(LINE2_Y2-(LINE2_Y1))/2,
    LINE2_X1+STEP2-2, LINE2_Y1+2,
    LINE2_X1+STEP2-2, LINE2_Y2-2
  },
  { LINE2_X2-2, LINE2_Y1+(LINE2_Y2-(LINE2_Y1))/2,
    LINE2_X2-STEP2+2, LINE2_Y1+2,
    LINE2_X2-STEP2+2, LINE2_Y2-2
  }
 };
 int lenx,leny,dx,dy,fx,fy,i;
 // ᮢ 
 CURSOR_OFF();
 setfillstyle( SOLID_FILL, BLACK );
 bar( 0, 12, 639, MAXY - 13 );
 setcolor( WHITE );
 rectangle( 2,14,637,MAXY - 15 );
 rectangle( 5,16,634,MAXY - 17 );
 //  ᮢ  
 setfillstyle( SOLID_FILL, LIGHTBLUE );
 bar( LINE1_X1, LINE1_Y1, LINE1_X2, LINE1_Y2);
 bar( LINE2_X1, LINE2_Y1, LINE2_X2, LINE2_Y2);
 setcolor( WHITE );
 rectangle( LINE1_X1, LINE1_Y1, LINE1_X2, LINE1_Y2);
 rectangle( LINE2_X1, LINE2_Y1, LINE2_X2, LINE2_Y2);

 setfillstyle( SOLID_FILL, WHITE );
 bar( 315 - 13*4, 14, 325 + 13*4, 26 );
 setfillstyle( SOLID_FILL, WHITE );
 bar( LINE1_X1, LINE1_Y1, LINE1_X2, LINE1_Y1+STEP1 );
 bar( LINE1_X1, LINE1_Y2-STEP1, LINE1_X2, LINE1_Y2);
 bar( LINE2_X1, LINE2_Y1, LINE2_X1+STEP2, LINE2_Y2);
 bar( LINE2_X2-STEP2, LINE2_Y1, LINE2_X2, LINE2_Y2);

 //  ᮢ   ࠭
 lenx= fx= LINE2_X2-LINE2_X1-2*STEP2;
 leny= fy= LINE1_Y2-LINE1_Y1-2*STEP1;
 dx=lenx/scrx; dy=leny/scry; lenx=dx*(numx-1); leny=dy*(numy-1);
 lenx=lenx<=0?0:(lenx>fx?fx:lenx); leny=leny<=0?0:(leny>fy?fy:leny);
 if (Max[Hor]>Param.Maxim[Hor]+Size[Hor]/5||Min[Hor]<Param.Minim[Hor]-Size[Hor]/5) dx=0;
 if (Max[Ver]>Param.Maxim[Ver]+Size[Ver]/5||Min[Ver]<Param.Minim[Ver]-Size[Ver]/5) dy=0;

 setfillstyle( SOLID_FILL, LIGHTRED );
 bar( LINE1_X1+1, LINE1_Y1+STEP1+leny, LINE1_X2-1, LINE1_Y1+STEP1+leny+dy );
 bar( LINE2_X1+STEP2+lenx, LINE2_Y1+1, LINE2_X1+STEP2+lenx+dx, LINE2_Y2-1 );
 setcolor( BLACK );
 setfillstyle( SOLID_FILL, BLACK );
 for(i = 0; i < 4; i++ )  fillpoly( 3, treg[i] );
 setcolor( LIGHTRED );
 outtextxy( 268 , 16, (char far *)"      " );
 CURSOR_ON();
 return;
}

///////////////////////////////////////////////////////////////////
//void Exclude ( int far *nr, int Ind, float far *Mat, float far *Vec);
//void Check_Opt (int n, float far *mu);
/* void Exclude ( int far *nr, int Ind, float far *Mat, float far *Vec) {
 int k;
 if (Ind>=0 && Ind<(*nr)) {
  for (k=Ind; k<(*nr)-1; k++) {
   Mat[3*k]=Mat[3*(k+1)];
   Mat[3*k+1]=Mat[3*(k+1)+1];
   Mat[3*k+2]=Mat[3*(k+1)+2];
   Vec[k]=Vec[k+1];
  }
  (*nr)-=1;
 }
 return;
} */

/* void Check_Opt (int n, float far *mu) {
 int i;
 for (i=0; i<n; i++) if (mu[i]<0.0 || mu[i]>1.0e+13) mu[i]=0.0;
 return;
}  */